unit MyFirstOlAddIn_IMPL;

interface

uses
  ComObj, ComServ, ActiveX, Variants, adxAddIn, MyFirstOlAddIn_TLB,
  Outlook2000, Classes, Dialogs;

type
  TOlAddIn = class(TadxAddin, IOlAddIn)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    MeExplBar: TadxOlExplorerCommandbar;
    MyInspBar: TadxOlInspectorCommandBar;
    procedure MeExplBarControls0Click(Sender: TObject);
    procedure MyInspBarControls0Click(Sender: TObject);
  private
  protected
    procedure OptionsPagesAdd(ASender: TObject;
      const Pages: PropertyPages); override;
    procedure NameSpaceOptionsPagesAdd(ASender: TObject;
      const Pages: PropertyPages; const Folder: MAPIFolder); override;
  public
  end;

var
  adxOlAddIn: TAddInModule;

implementation

{$R *.dfm}

procedure TAddInModule.OptionsPagesAdd(ASender: TObject; const Pages: PropertyPages);
begin
  Pages.Add('MyFirstOlAddIn.OptionPage', 'MyOptions');
end;

procedure TAddInModule.NameSpaceOptionsPagesAdd(ASender: TObject;
  const Pages: PropertyPages; const Folder: MAPIFolder);

  function GetFullFolderName(const AFolder: MAPIFolder): string;
  var
    IDisp: IDispatch;
    Folder: MAPIFolder;
  begin
    Result := '';
    Folder := AFolder;
    while Assigned(Folder) do begin
      Result := '\' + Folder.Name + Result;
      IDisp := Folder.Parent;
      IDisp.QueryInterface(IID_MAPIFolder, Folder);
    end;
    if Result <> '' then Delete(Result, 1, 1);
  end;

begin
  Pages.Add('MyFirstOlAddIn.GlobalPropertyPage', 'MyOptions');
  if GetFullFolderName(Folder) = 'My Personal Folders\Inbox' then
    Pages.Add('MyFirstOlAddIn.InboxPropertyPage', 'InboxOptions');
end;

procedure TAddInModule.MeExplBarControls0Click(Sender: TObject);
begin
  ShowMessage('It is my button on the Explorer command bar!');
end;

procedure TAddInModule.MyInspBarControls0Click(Sender: TObject);
begin
  ShowMessage('It is my button on the Explorer command bar!');
end;

initialization
  TadxFactory.Create(ComServer, TOlAddIn, CLASS_OlAddIn, TAddInModule);

end.
